/*********************************************************************/
/* Copyright (C) 2008  NEC Research Laboratories

Authors:    Ettore Ferranti
            Ettore.Ferranti@nw.neclab.eu
	    NEC Research Laboratories
	    Heidelberg, Germany

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/*********************************************************************/
#include "as.h"
#include "router.h"
#include "misc.h"

AS::AS(AS_ID id)
{
	this->id=id;
}

AS_ID AS::getID()
{
	return id;
}

void AS::addRouter(PRouter router)
{
	if(routers.count(router->getId())>0)
	{
		routers.erase(router->getId());
	}
	router->set_as(this);
	routers[router->getId()]=router;
}

void AS::addLink(AS_ID id,Latency latency)
{
	if(latencies.count(id)>0)
	{
		latencies.erase(id);
	}
	latencies[id]=latency;
}

Latency AS::getLatency(AS_ID id)
{
	if (latencies.count(id)<=0) {
			fatal("Attempt made to get latency from non-existent as:");
		}
	return latencies[id];
}
