/*********************************************************************/
/* Copyright (C) 2008  NEC Research Laboratories

Authors:    Ettore Ferranti
            Ettore.Ferranti@nw.neclab.eu
	    NEC Research Laboratories
	    Heidelberg, Germany

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/*********************************************************************/

#ifndef AS_H_
#define AS_H_

#include <map>
#include "types.h"

class AS
{
	std::map<AS_ID,Latency> latencies;
	std::map<RouterID,PRouter> routers;
	AS_ID id;

public:
        /// default constructor, initialise the AS with the specified ID.
	AS(AS_ID id);
        /// add a link between the current AS and another AS with the specified latency.
	void addLink(AS_ID id,Latency latency);
        /// get the latency between the current AS and the specified one.
	Latency getLatency(AS_ID id);
        /// add a router to the current AS
	void addRouter(PRouter router);
        /// returns the ID of the current AS.
	AS_ID getID();
};



#endif /* AS_H_ */
