/*********************************************************************/
/* Copyright (C) 2009 University of Trento

Authors:    Jovan Stevovic,Csaba Kiraly
			Telecomunication Networks Group
			University of Trento
			Trento, Italy
			kiraly@disi.unitn.it

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/*********************************************************************/

/*! @file
    Defines the ChunkInstance class. This represents a copy of a chunk
	at a given peer.
 */

#ifndef _CHUNKINSTANCE_H
#define	_CHUNKINSTANCE_H

#include "types.h"
#include "chunk.h"

class ChunkInstance {

private:
    PChunkPointer c_chunk;
    ChunkDeadline c_dl;

public:
    ChunkInstance(ChunkID id, Time time, ChunkSize size, ChunkType type, bool par = false);
    ChunkInstance(PChunk chunk);
    ChunkID id();
    Time initiation_time();
    ChunkDeadline dl();
    void set_dl(ChunkDeadline dl);
    PChunkPointer chunk_pointer();
    void set_chunk(Chunk* chunk);
    bool parity();
    inline ChunkSize size() { return c_chunk->size(); }
    inline ChunkType type() { return c_chunk->type(); }
};

#endif	/* _CHUNKINSTANCE_H */

