/*********************************************************************/
/* Copyright (C) 2008  Politecnico di Torino

 Authors: Marco Mellia, Gloria Bogliolo, Ana Paula Couto, Richard Lobb
  	      Telecomunication Networks Group
  	      Politecnico di Torino
  	      Torino, Italy
  	      mellia@mail.tlc.polito.it, anapaula@tlc.polito.it

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/*********************************************************************/

/*! @file
    Defines the FullOverlay subclass of the Overlay class. This is a
	fully-connected degree n-1 overlay.
 */

#include "fulloverlay.h"

// The FullOverlay
// -------------

FullOverlay::FullOverlay(size_t num_peers) {
	set_peers(num_peers);  // See MBWOverlay
	set_edges();
}

// Set up each peer with a random neighbourhood of the
// specified degree.

void FullOverlay::set_edges()
{
	for (size_t i = 0; i < num_peers()-1; i++){
	        for (size_t j = i+1; j < num_peers(); j++){
			add_link (i, j);
			add_link (j, i);
		}
	}
}


