/*********************************************************************/
/* Copyright (C) 2008  Politecnico di Torino

Authors:    Marco Mellia, Gloria Bogliolo, Ana Paula Couto, Richard Lobb
			Telecomunication Networks Group
			Politecnico di Torino
			Torino, Italy
			mellia@mail.tlc.polito.it, anapaula@tlc.polito.it

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/*********************************************************************/

/*! @file
	Defines the FullOverlay class, which is an overlay in which each
	peer is connected to every other peer.
 */

#ifndef _FULL_OVERLAY_H_
#define _FULL_OVERLAY_H_

#include "types.h"
#include "mbwoverlay.h"

/// A FullOverlay is an MBWOverlay in which each host is connected to each other,
/// i.e. it forms a fully connected graph
class FullOverlay : public MBWOverlay {
public:
        ///there is no degree parameter, of course
	FullOverlay(
		size_t num_peers	///< Number of peers in overlay
	);
private:
	void set_edges();
};


#endif // _FULL_OVERLAY_H_
