/*********************************************************************/
/* Copyright (C) 2008  Politecnico di Torino

 Authors: Marco Mellia, Gloria Bogliolo, Ana Paula Couto, Richard Lobb
  	      Telecomunication Networks Group
  	      Politecnico di Torino
  	      Torino, Italy
  	      mellia@mail.tlc.polito.it, anapaula@tlc.polito.it

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/*********************************************************************/

/*! @file
    Defines the GNPOverlay, which is subclass of MBWOverlay in which
	neighbours are chosen randomly and the degree of each peer is determined
	by a poisson process.
 */

#ifndef _GNP_OVERLAY_H_
#define _GNP_OVERLAY_H_

#include "mbwoverlay.h"


class GNPOverlay : public MBWOverlay {
public:
	/// Constructor. 
	GNPOverlay(
		size_t num_peers,	///< Number of peers in overlay
		size_t degree		///< The 'rate' of the poisson process used to select
							///< the number of neighbours to choose for each peer
	);
private:
	void set_edges(size_t degree);
};


#endif // _OVERLAY_TYPES_H_
