/*********************************************************************/
/* Copyright (C) 2008  Politecnico di Torino

 Authors: Maurizio Munafo', Marco Mellia, Richard Lobb, Gloria Bogliolo, 
/*********************************************************************/
/* Copyright (C) 2008  Politecnico di Torino

Authors:    Maurizio Munafo', Marco Mellia, Gloria Bogliolo, 
            Ana Paula Couto, Richard Lobb
			Telecomunication Networks Group
			Politecnico di Torino
			Torino, Italy
			mellia@mail.tlc.polito.it, anapaula@tlc.polito.it

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/*********************************************************************/

/*! @file 
	Defines the Link class, which represents edges in the Overlay class.
 */

#include <deque>
#include "link.h"

/// Constructor
Link::Link(PPeer from, PPeer to) : l_from(from), l_to(to) {};


/// A pointer to the link's LinksStats record, used to maintain
/// purely statistical information about the link and, say, chunk
/// flows along it.
PLinkStats Link::stats() {
	return &l_stats;
}

/// Clear any simulation or statistics data associated with the link.
/// Called for each link when the Overlay::clear() method is called.
void Link::clear() {
	l_stats.clear();
}

