/*********************************************************************/
/* Copyright (C) 2008  Politecnico di Torino

 Authors: Marco Mellia, Gloria Bogliolo, Ana Paula Couto, Richard Lobb
  	      Telecomunication Networks Group
  	      Politecnico di Torino
  	      Torino, Italy
  	      mellia@mail.tlc.polito.it, anapaula@tlc.polito.it

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/*********************************************************************/

/*! @file misc.h
	A file of miscellaneous functions that have no obvious home.
 */
#ifndef _MISC_H_
#define _MISC_H_

#include <cstdio>
#include <string>
#include <limits>
#include <vector>

/// Issue an error message and exit.
void fatal(std::string message);

/// Try to open the given file for writing.
/// Return the file pointer if successful, else issue error message and exit.
FILE* check_open(std::string filename) ;

/// True iff parameter is infinity
inline bool is_infinite(double x) {
	return x == std::numeric_limits<double>::infinity();
}

/// Return a random vector of n size_t's in range min .. max inclusive.
std::vector<size_t> random_ints(size_t n, size_t min, size_t max);

#endif
