/*********************************************************************/
/* Copyright (C) 2008  Politecnico di Torino

Authors:    Marco Mellia, Gloria Bogliolo, Ana Paula Couto, Richard Lobb
			Telecomunication Networks Group
			Politecnico di Torino
			Torino, Italy
			mellia@mail.tlc.polito.it, anapaula@tlc.polito.it

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/*********************************************************************/

/*! @file
	Declares the TreeOverlay class, a tree-structured directed graph.
 */

#ifndef _TREE_OVERLAY_H_
#define _TREE_OVERLAY_H_

#include "mbwoverlay.h"

/// A TreeOverlay is an MBWOverlay that's a tree with peer 0 as the root.
/// Unlike the other overlays in this file, a TreeOverlay is directed.
class TreeOverlay : public MBWOverlay {
public:
	/// Constructor.
	TreeOverlay(
		size_t num_peers,	///< The number of peers in the overlay
		size_t degree,		///< The 'rate' of the poisson process used
							///< to select the degree of each internal peer
		size_t max_degree	///< The maximum degree allowed
	);
private:
	void set_edges(size_t degree, size_t max_degree);
};

#endif // _TREE_OVERLAY_H_
